#include "../include/GPU/gpu.hpp"

namespace JabyEngine {
    namespace GPU {
        uint8_t Screen :: CurrentDisplayAreaID = 1; //< Setup will call exchange and set it to 0

        #ifdef JABYENGINE_PAL
            static constexpr uint16_t ScanlinesV = 288;
        #else
            static constexpr uint16_t ScanlinesV = 240;
        #endif //JABYENGINE_PAL

        void ScreenHelper :: exchange_buffer_and_display() {
            GPU::set_draw_area(0, (Display::Height*Screen::CurrentDisplayAreaID));
            Screen::CurrentDisplayAreaID ^= 1;
            GPU_IO::GP1.write(GPU_IO::Command::GP1::DisplayArea(0, (Display::Height*Screen::CurrentDisplayAreaID)));
        }

        #ifndef USE_NO$PSX
            void Screen :: set_offset(uint16_t x, uint16_t y) {
                x += 78;
                y += 43;

                GPU_IO::GP1.write(GPU_IO::Command::GP1::HorizontalDisplayRange((x << 3), (x + Display::Width) << 3));
                GPU_IO::GP1.write(GPU_IO::Command::GP1::VerticalDisplayRange(y,         y + Display::Height));
            }
        #else
            void Screen :: set_offset(uint16_t x, uint16_t y) {
                GP1.write(Command::GP1::HorizontalDisplayRange(x, (x + Display::Width*8)));
                GP1.write(Command::GP1::VerticalDisplayRange(y - (ScanlinesV/2), y + (ScanlinesV/2)));
            }
        #endif //USE_NO$PSX
    }

}